#!/usr/bin/python

from ftplib import FTP
from ftplib import FTP_TLS
import hashlib
import os
import ssl
import sys
import time
import requests
import executor
import subprocess
import shutil
from executor import execute
from kubernetes import client, config

class MyFTP(FTP):
    '''
    connect to FTP Server
    '''
    def __init__(self):
        print('make a object')


    def ConnectFTP(self, remote_ip="", remote_port=21, login_name="", login_password=""):
        # ftp = FTP()
        ftp = FTP_TLS()
        ftp.ssl_version = ssl.PROTOCOL_TLSv1_2

        try:
            ftp.connect(remote_ip, remote_port, 600)
            print('Connect Success')
        except Exception as e:
            print(sys.stderr, "Coonnect Failed - %s" %e)
            return (0, 'Connect Failed')
        else:
            try:
                ftp.login(login_name, login_password)
                print('login Success')
            except Exception as e:
                print(sys.stderr, "Login Failed - %s" %e)
                return (0, 'Login Faild')
            else:
                print('retrun 1')
                return (1, ftp)


    def Download(self, remoteHost="", remotePort="", login_name="", login_password="", remotePath="", localPath=""):
        # connect to the FTP Server and check the return
        res = self.ConnectFTP(remote_ip=remoteHost, remote_port=remotePort, login_name=login_name, login_password=login_password)
        if (res[0] != 1):
            print(sys.stderr, res[1])
            sys.exit(1)


        # change the remote directory and get the remote file size
        ftp = res[1]
        ftp.set_pasv(1)
        dires = self.splitpath(remotePath)
        # if dires[0]:
        #     # change remote work dir
        #     ftp.cwd(dires[0])
        remotefile = dires[1]
        print(dires[0],'---',dires[1])
        fsize = ftp.size(remotefile)
        if fsize == 0:
            return

        # check if local file exists and get the local file size
        lsize = 0
        if os.path.exists(localPath):
            lsize = os.stat(localPath).st_size

        if lsize >= fsize:
            print('local file is bigger or equal remote file')
            return

        blocksize = 1024*1024
        cmpsize = lsize
        ftp.voidcmd('TYPE I')
        conn = ftp.transfercmd('RETR ' + remotefile, lsize)
        lwrite = open(localPath, 'ab')
        while True:
            data = conn.recv(blocksize)
            if not data:
                break
            lwrite.write(data)
            cmpsize += len(data)
            print('\b'*30,'download process:%.2f%%'%(float(cmpsize)/fsize*100))
        lwrite.close()
        ftp.voidcmd('NOOP')
        ftp.voidresp()
        conn.close()


    def splitpath(self, remotepath):
        position = remotepath.rfind('/')
        return (remotepath[:position + 1], remotepath[position + 1:])

    def md5_calc(self, file):
        md5_value = hashlib.md5()
        with open(file, 'rb') as file_b:
            while True:
                data_flow = file_b.read(8096)  # 每次读入8089kb进入内存
                if not data_flow:  # 读取完后返回空值，False
                    break
                md5_value.update(data_flow)
        file_b.close()
        return md5_value.hexdigest()

    def get_filesize(self, filename):
        fsize = os.path.getsize(filename)
        return fsize


def download_file_from_ftp(login_name, login_password, remotefile, localPath):
    try:
        ftpobj = MyFTP()
        ftpobj.Download(
            remoteHost='165.73.249.37',
            remotePort=10021,
            login_name=login_name,
            login_password=login_password,
            remotePath="/ftp-download/" + remotefile,
            localPath=localPath
        )
    except Exception as e:
        print(f"下载文件失败: {e}")
        return False


def caculate_template_md5(template_filename):
    url = "https://download-md5.cloudclusters.io/submit_md5"
    headers = {
        "Content-Type": "application/json"
    }
    auth = ("LIMIT", "LIMIT")  # 用户名和密码
    data = {
        "file_name": template_filename
    }

    try:
        # 发送 POST 请求
        response = requests.post(url, headers=headers, auth=auth, json=data)

        # 检查响应状态码
        if response.status_code in [200,201,202]:
            return response.json()  # 返回响应的 JSON 数据
        else:
            print(f"请求失败，状态码: {response.status_code}")
            print(f"响应内容: {response.text}")
            return None
    except Exception as e:
        print(f"请求时发生错误: {e}")
        return None


def get_template_md5(template_filename, max_retries=20, retry_interval=30):
    """
    不断重试获取文件的 MD5 值，直到请求成功（状态码为 200 或 201），或达到最大重试次数。

    :param template_filename: 文件名
    :param max_retries: 最大重试次数，默认 10 次
    :param retry_interval: 每次重试的时间间隔（秒），默认 30 秒
    :return: 返回 MD5 值的 JSON 数据，或者 None（如果最终失败）
    """
    url = "https://download-md5.cloudclusters.io/check_md5"
    headers = {
        "Content-Type": "application/json"
    }
    auth = ("LIMIT", "LIMIT")  # 用户名和密码
    data = {
        "file_name": template_filename
    }

    for attempt in range(1, max_retries + 1):
        try:
            # 发送 GET 请求
            response = requests.post(url, headers=headers, auth=auth, json=data)

            # 检查响应状态码
            if response.status_code in [200, 201]:
                print(f"成功获取 MD5 值: {response.json()}")
                return response.json()  # 返回响应的 JSON 数据
            else:
                print(f"请求失败，状态码: {response.status_code}, 尝试 {attempt}/{max_retries}")
                print(f"响应内容: {response.text}")
        except Exception as e:
            print(f"请求时发生错误: {e}, 尝试 {attempt}/{max_retries}")

        # 如果未达到最大重试次数，等待一段时间后重试
        if attempt < max_retries:
            print(f"等待 {retry_interval} 秒后重试...")
            time.sleep(retry_interval)

    print("重试次数已用尽，获取 MD5 值失败。")
    return None


def create_symlink(file_name):
    """
    调用远程 API 创建软链接。

    :param file_name: 文件名（用于创建软链接的源文件）
    :return: API 返回的 JSON 数据或 None（如果失败）
    """
    url = "https://download-md5.cloudclusters.io/create_symlink"
    headers = {
        "Content-Type": "application/json"
    }
    auth = ("LIMIT", "LIMIT")  # 用户名和密码
    data = {
        "file_name": file_name
    }

    try:
        # 发送 POST 请求
        response = requests.post(url, headers=headers, auth=auth, json=data)

        # 检查响应状态码
        if response.status_code in [200, 201]:
            print("软链接创建成功！")
            return response.json()  # 返回响应的 JSON 数据
        else:
            print(f"请求失败，状态码: {response.status_code}")
            print(f"响应内容: {response.text}")
            return None

    except Exception as e:
        print(f"请求时发生错误: {e}")
        return None


class AtomError(Exception):
    def __init__(self, msg):
        self.message = msg

    def __str__(self):
        return self.message


class RestoreLVM(object):
    def __init__(self):
        self.backup_lvm_name_suffix = '.old'
        self.mount_datadir_prefix = "/data"


    def exists_lvm(self, lvm_fullname=""):
        if os.path.exists(lvm_fullname.rstrip('/')):
            return True
        else:
            return False


    def umount_datadir(self, stackname=""):
        mount_datadir = self.mount_datadir_prefix.rstrip('/') + '/' + stackname
        cmd = "umount {mount_path}".format(mount_path=mount_datadir)

        res = subprocess.getstatusoutput(cmd)
        res_code = res[0]
        res_content = res[1]
        if int(res_code) == 0:
            return True
        else:
            print(res_content)
            return False


    def rename_lvm(self, lvm_fullname="", stackname=""):
        lvm_new_name = stackname + self.backup_lvm_name_suffix
        cmd = "lvrename {lvm_old_fullname} {lvm_new_name}".format(lvm_old_fullname=lvm_fullname, lvm_new_name=lvm_new_name)
        res = subprocess.getstatusoutput(cmd)
        res_code = res[0]
        res_content = res[1]
        if int(res_code) == 0:
            return True
        else:
            print(res_content)
            return False


    def get_lvm_info(self, stackname=""):
        cmd = 'lvs  -o lv_size,pool_lv,lv_full_name 2>/dev/null|grep -w {stackname}|grep pool|head -n 1'.format(stackname=stackname)
        res = subprocess.getstatusoutput(cmd)
        res_code = res[0]
        if res[1] == '':
            print("LVM [{lvm_name}] 不存在".format(lvm_name=stackname))
        else:
            res_content = res[1].strip().split()
            print(res_content)
            if int(res_code) == 0:
                lvm_size = res_content[0]
                pool_name = res_content[1]
                lvm_name = res_content[2]
                kwargs = {
                    "lvm_size": lvm_size,
                    "pool_name": pool_name,
                    "lvm_name": lvm_name,
                }
                return kwargs


    def create_lvm(self, stackname="", pool_name="", lvm_size=""):
        lvm_name = stackname
        pool_id = pool_name.split('pool')[1]
        vg_name = 'vg' + pool_id
        cmd = 'lvcreate -V {size} -T {vg_name}/{pool_name} -n {lvm_name}'.format(size=lvm_size, vg_name=vg_name, pool_name=pool_name, lvm_name=lvm_name)
        print(cmd)
        res = subprocess.getstatusoutput(cmd)
        res_code = res[0]
        res_content = res[1]
        if int(res_code) == 0:
            return True
        else:
            print(res_content)
            return False


    def format_lvm(self, lvm_fullname=""):
        cmd = 'mkfs.ext4  {lvm_fullname}'.format(lvm_fullname=lvm_fullname)
        res = subprocess.getstatusoutput(cmd)
        res_code = res[0]
        res_content = res[1]
        if int(res_code) == 0:
            return True
        else:
            print(res_content)
            return False


    def mount_new_lvm_to_datadir(self, lvm_fullname="", stackname=""):
        mount_datadir = self.mount_datadir_prefix.rstrip('/') + '/' + stackname

        if not os.path.exists(mount_datadir):
            os.makedirs(mount_datadir)

        cmd = 'mount -o discard {block_device} {mount_path} '.format(block_device=lvm_fullname, mount_path=mount_datadir)
        res = subprocess.getstatusoutput(cmd)
        res_code = res[0]
        res_content = res[1]
        if int(res_code) == 0:
            return True
        else:
            print(res_content)
            return False


    def unzip_backup_to_datadir(self, backup_file_fullname="", stackname=""):
        mount_datadir = self.mount_datadir_prefix.rstrip('/') + '/' + stackname
        print(mount_datadir)
        cmd = 'tar -xf  {backup_file_fullname} -C {mount_datadir}'.format(backup_file_fullname=backup_file_fullname, mount_datadir=mount_datadir)
        res = subprocess.getstatusoutput(cmd)
        res_code = res[0]
        res_content = res[1]
        if int(res_code) == 0:
            return True
        else:
            print(res_content)
            return False


    def undo_remount(self, lvm_fullname="", stackname=""):
        bak_lvm_name = lvm_fullname + self.backup_lvm_name_suffix
        mount_datadir = self.mount_datadir_prefix.rstrip('/') + '/' + stackname
        # 如果老的备份逻辑卷存在，则改回原来的名字
        if os.path.exists(bak_lvm_name):

            # 重命名到原来的，回退操作
            if os.path.exists(lvm_fullname):
                # 检查是否已经挂载, 如果挂载了则取消挂载
                if os.path.ismount(mount_datadir):
                    cmd_umount = 'umount {lvm_name}'.format(lvm_name=lvm_fullname)
                    executor.execute(cmd_umount)
                else:
                    pass

                # 删除原来的lvm
                cmd_remove = 'lvremove {lvm_name} -y'.format(lvm_name=lvm_fullname)
                executor.execute(cmd_remove)

            # 重命名原来的
            cmd_rename = "lvrename {lvm_old_fullname} {lvm_new_name}".format(lvm_old_fullname=bak_lvm_name, lvm_new_name=lvm_fullname)
            executor.execute(cmd_rename)

            # mount_datadir = self.mount_datadir_prefix.rstrip('/') + '/' + stackname
            # cmd_mount = 'mount -o discard {block_device} {mount_path} '.format(block_device=lvm_fullname,
            #                                                              mount_path=mount_datadir)
            # executor.execute(cmd_mount)

        # 老的逻辑卷不存在, 重新挂载旧的
        else:
            pass
            # mount_datadir = self.mount_datadir_prefix.rstrip('/') + '/' + stackname
            # cmd_mount = 'mount -o discard {block_device} {mount_path} '.format(block_device=lvm_fullname,
            #                                                                    mount_path=mount_datadir)
            # executor.execute(cmd_mount)



    def remove_bak_lvm(self, lvm_fullname=""):
        old_lvm_name = lvm_fullname + self.backup_lvm_name_suffix
        print(old_lvm_name)
        cmd = 'lvremove {old_lvm_name} -y'.format(old_lvm_name=old_lvm_name)
        res = subprocess.getstatusoutput(cmd)
        res_code = res[0]
        res_content = res[1]
        print(res)
        if int(res_code) == 0:
            return True
        else:
            print(res_content)
            return False


    def restore_lvm_process(self, stackname="", lvm_fullname="", pool_name="", lvm_size="", backup_file_fullname=""):
        flag = False
        # 1、 先判断 LVM 逻辑卷是否存在该节点，不存在则没法进行备份
        is_lvm_existed = self.exists_lvm(lvm_fullname=lvm_fullname)
        if is_lvm_existed:
            flag = True
            log_info1 = "1. LVM [{lvm_fullname}] 存在于该主机，开始恢复备份".format(lvm_fullname=lvm_fullname)
            print(log_info1)
        else:
            log_info1 = "1. LVM [{lvm_fullname}] 不存在于该主机，无法恢复备份".format(lvm_fullname=lvm_fullname)
            print(log_info1)
            raise AtomError(f"1. LVM [{lvm_fullname}] not existed, can't restore data")


        if flag:
            # 2 将原有的 LVM 重命名为 lvm-old
            lvm_old_fullname = lvm_fullname
            lvm_new_fullname = lvm_fullname + self.backup_lvm_name_suffix
            lvm_renamed = self.rename_lvm(lvm_fullname=lvm_fullname, stackname=stackname)
            if lvm_renamed:
                flag = True
                log_info2 = "2. 将原有的 LVM [{lvm_old_fullname}] 重命名为 [{lvm_new_fullname}] 成功".format(lvm_old_fullname=lvm_old_fullname, lvm_new_fullname=lvm_new_fullname)
                print(log_info2)
            else:
                self.undo_remount()
                log_info2 = "2. 将原有的 LVM [{lvm_old_fullname}] 重命名为 [{lvm_new_fullname}] 失败".format(lvm_old_fullname=lvm_old_fullname, lvm_new_fullname=lvm_new_fullname)
                print(log_info2)
                raise AtomError(f"2. Rename LVM [{lvm_old_fullname}] failed")

        if flag:
            # 3、创建新的 LVM
            new_lvm_created = self.create_lvm(stackname=stackname, pool_name=pool_name, lvm_size=lvm_size)
            if new_lvm_created:
                flag = True
                log_info3 = "3、 创建新的 LVM [{lvm_fullname}] 成功".format(lvm_fullname=lvm_fullname)
                print(log_info3)
            else:
                self.undo_remount()
                log_info3 = "3、 创建新的 LVM [{lvm_fullname}] 失败".format(lvm_fullname=lvm_fullname)
                print(log_info3)
                raise AtomError(f"3. Create LVM [{lvm_fullname}] failed")

        if flag:
            # 4、 格式化新的 LVM
            lvm_formated = self.format_lvm(lvm_fullname=lvm_fullname)
            if lvm_formated:
                flag = True
                log_info4 = "4、 格式化新的 LVM [{lvm_fullname}] 成功".format(lvm_fullname=lvm_fullname)
                print(log_info4)
            else:
                self.undo_remount()
                log_info4 = "4、 格式化新的 LVM [{lvm_fullname}] 失败".format(lvm_fullname=lvm_fullname)
                print(log_info4)
                raise AtomError(f"4. Format LVM [{lvm_fullname}] failed")

        if flag:
            # 5、挂载新的 LVM 到数据目录
            mount_new_lvm_to_datadir_finish = self.mount_new_lvm_to_datadir(lvm_fullname=lvm_fullname, stackname=stackname)
            mount_datadir = self.mount_datadir_prefix.rstrip('/') + '/' + stackname
            if mount_new_lvm_to_datadir_finish:
                flag = True
                log_info5 = "5、 挂载新的 LVM [{lvm_fullname}] 到数据目录 [{mount_datadir}] 成功".format(lvm_fullname=lvm_fullname, mount_datadir=mount_datadir)
                print(log_info5)
            else:
                self.undo_remount()
                log_info5 = "5、 挂载新的 LVM [{lvm_fullname}] 到数据目录 [{mount_datadir}] 失败".format(lvm_fullname=lvm_fullname, mount_datadir=mount_datadir)
                print(log_info5)
                raise AtomError(f"5. Mount LVM [{lvm_fullname}] to datadir failed")

        if flag:
            # 6、将备份文件解压到数据目录
            mount_datadir = self.mount_datadir_prefix.rstrip('/') + '/' + stackname
            unzip_backup_to_datadir_finish = self.unzip_backup_to_datadir(stackname=stackname,backup_file_fullname=backup_file_fullname)
            if unzip_backup_to_datadir_finish:
                flag = True
                log_info6 = "6、 将备份文件 [{backup_file_fullname}] 解压到数据目录 [{mount_datadir}] 成功".format(backup_file_fullname=backup_file_fullname, mount_datadir=mount_datadir)
                print(log_info6)
            else:
                self.undo_remount()
                log_info6 = "6、 将备份文件 [{backup_file_fullname}] 解压到数据目录 [{mount_datadir}] 失败".format(backup_file_fullname=backup_file_fullname, mount_datadir=mount_datadir)
                print(log_info6)
                raise AtomError(f"6. Unzip backup file [{backup_file_fullname}] to datadir failed")


        if flag:
            # 7  umount 数据目录
            mount_datadir = self.mount_datadir_prefix.rstrip('/') + '/' + stackname
            umountd_datadir = self.umount_datadir(stackname=stackname)
            if umountd_datadir:
                flag = True
                log_info7 = "7. Umount 数据目录 [{mount_datadir}] 成功".format(mount_datadir=mount_datadir)
                print(log_info7)

                try:
                    if os.path.exists(mount_datadir):
                        shutil.rmtree(mount_datadir)
                        print("7.删除数据挂载目录成功")
                except:
                    print("7. 删除数据挂载目录失败")

            else:
                log_info7 = "7. Umount 数据目录 [{mount_datadir}] 失败".format(mount_datadir=mount_datadir)
                print(log_info7)
                raise AtomError(f"7. Umount datadir [{mount_datadir}] failed")


        if flag:
            # 8、 删除备份的 LVM
            old_lvm_name = lvm_fullname + self.backup_lvm_name_suffix
            old_lvm_deleted = self.remove_bak_lvm(lvm_fullname=lvm_fullname)
            if old_lvm_deleted:
                flag = True
                log_info8 = "8、删除备份的 LVM [{old_lvm_name}] 成功".format(old_lvm_name=old_lvm_name)
                print(log_info8)
            else:
                self.undo_remount()
                log_info8 = "8、删除备份的 LVM [{old_lvm_name}] 失败".format(old_lvm_name=old_lvm_name)
                print(log_info8)
                raise AtomError(f"8. Remove backup LVM [{old_lvm_name}] failed")


        if flag:
            log_info9 = "9、恢复应用 [{stackname}] 成功".format(stackname=stackname)
            print(log_info9)
            return True
        else:
            log_info9 = "9、恢复应用 [{stackname}] 失败".format(stackname=stackname)
            print(log_info9)
            return False


    def restore_data(self, stackname="", backup_file_fullname=""):
        lvm_info = self.get_lvm_info(stackname=stackname)
        lvm_size = lvm_info.get("lvm_size")
        pool_name = lvm_info.get("pool_name")
        lvm_name = lvm_info.get("lvm_name")
        lvm_fullname = '/dev/' + lvm_name

        return self.restore_lvm_process(stackname=stackname, lvm_fullname=lvm_fullname, pool_name=pool_name,
                                        lvm_size=lvm_size, backup_file_fullname=backup_file_fullname)



class PODinfo:
    def __init__(self, namespace="default"):
        self._kubeconf = "/root/.kube/config"
        self._namespace = namespace
        self._pod_name = self.get_pod_name()


    def get_pod_info(self, namespace=""):
        pod_info_list = []
        pod_info_dic = {}
        v1 = client.CoreV1Api()
        a = v1.list_namespaced_pod(namespace=namespace)
        for i in a.items:
            pod_name = i.metadata.name
            if "jcyftp" in pod_name:
                pass
            elif "cockroach-job" in pod_name:
                pass
            elif "acme" in pod_name:
                pass
            else:
                pod_pvc_name = i.spec.volumes[0].persistent_volume_claim.claim_name
                pod_info_dic["podname"] = pod_name
                pod_info_dic["pvcname"] = pod_pvc_name
                pod_info_list.append(pod_info_dic)
        return pod_info_list


    def read_pod_info(self, namespace="", podname=""):
        v1 = client.CoreV1Api()
        node_name = v1.read_namespaced_pod(namespace=namespace, name=podname).spec.node_name
        return node_name


    def get_pod_name(self):
        config.load_kube_config(self._kubeconf)
        v1 = client.CoreV1Api()
        pod_list = []
        try:
            for i in v1.list_namespaced_pod(self._namespace).items:
                pod_list.append(i.metadata.name)
        except:
            pass
        return pod_list


    def get_statefulset_replicas(self):
        config.load_kube_config(self._kubeconf)
        v1 = client.AppsV1Api()
        replicas = None
        for i in v1.list_namespaced_stateful_set(self._namespace).items:
            replicas = i.spec.replicas
        return replicas

    def get_deployment_replicas(self):
        config.load_kube_config(self._kubeconf)
        v1 = client.AppsV1Api()
        replicas = None
        for i in v1.list_namespaced_deployment(self._namespace).items:
            replicas = i.spec.replicas
        return replicas


    def get_controller_kind(self, pod_name, namespace):
        api_instance = client.AppsV1Api()
        namespace = self._namespace
        api_response = client.CoreV1Api().read_namespaced_pod(pod_name, namespace)
        controller = api_response.metadata.owner_references[0]
        return controller.kind


    def get_statefulset_name(self):
        config.load_kube_config(self._kubeconf)
        v1 = client.AppsV1Api()
        statefulset_name = None
        for i in v1.list_namespaced_stateful_set(self._namespace).items:
            statefulset_name = i.metadata.name
        return statefulset_name

    def get_deployment_name(self):
        config.load_kube_config(self._kubeconf)
        v1 = client.AppsV1Api()
        deployment_name = None
        for i in v1.list_namespaced_deployment(self._namespace).items:
            deployment_name = i.metadata.name
            print(deployment_name)
        return deployment_name


    def stop_pod_statefulset(self, statefulset_name):
        try:
            cmd_stop_pod = "kubectl scale statefulset/{statefulset} --replicas=0 -n {namespace}".format(
                statefulset=statefulset_name, namespace=self._namespace)
            execute(cmd_stop_pod)
            pod_list = self.get_pod_name()
            n = 0
            while n <= 300:
                for pod_name in pod_list:
                    pod_status = self.get_pod_status(pod_name)
                    if pod_status == '404' or pod_status == 'Succeeded':
                        pod_list.remove(pod_name)
                if len(pod_list) == 0:
                    break
                else:
                    time.sleep(2)
                    n = n + 1
                    continue
        except Exception as e:
            print(e)

    def stop_pod_deployment(self, deployment_name):
        cmd_stop_pod = "kubectl scale deployment/{deployment_name} --replicas=0 -n {namespace}".format(
            deployment_name=deployment_name, namespace=self._namespace)
        execute(cmd_stop_pod)
        pod_list = self.get_pod_name()
        n = 0
        while n <= 300:
            for pod_name in pod_list:
                pod_status = self.get_pod_status(pod_name)
                if pod_status == '404' or pod_status == 'Succeeded':
                    pod_list.remove(pod_name)
            if len(pod_list) == 0:
                break
            else:
                time.sleep(2)
                n = n + 1
                continue

    def get_pod_status(self, pod_name):
        config.load_kube_config(self._kubeconf)
        v1 = client.CoreV1Api()
        try:
            pod_status = v1.read_namespaced_pod_status(pod_name, self._namespace).status.phase
        except:
            pod_status = "404"
            return pod_status
        else:
            return pod_status


    def start_pod_statefulset(self, replicas, statefulset_name):
        cmd_start_pod = "kubectl scale statefulset/{statefulset} --replicas={replicas} -n {namespace}".format(
            statefulset=statefulset_name, replicas=replicas, namespace=self._namespace)
        execute(cmd_start_pod)
        n = 0
        while n <= 3600:
            try:
                statefulset_status = self.get_statefulset_status()
                if statefulset_status:
                    break
            except:
                time.sleep(2)
                n = n + 1
                continue


    def start_pod_deployment(self, replicas, deployment_name):
        cmd_start_pod = "kubectl scale deployment/{deployment_name} --replicas={replicas} -n {namespace}".format(
            deployment_name=deployment_name, replicas=replicas, namespace=self._namespace)
        execute(cmd_start_pod)
        n = 0
        while n <= 3600:
            try:
                deployment_status = self.get_deployment_status()
                if deployment_status:
                    break
            except:
                time.sleep(2)
                n = n + 1
                continue

    def get_statefulset_status(self):
        config.load_kube_config(self._kubeconf)
        v1 = client.AppsV1Api()
        for i in v1.list_namespaced_stateful_set(self._namespace).items:
            replicas = i.status.replicas
            ready_replicas = i.status.ready_replicas
        if ready_replicas == replicas:
            return True
        else:
            return False

    def get_deployment_status(self):
        config.load_kube_config(self._kubeconf)
        v1 = client.AppsV1Api()
        for i in v1.list_namespaced_deployment(self._namespace).items:
            replicas = i.status.replicas
            ready_replicas = i.status.ready_replicas
        if ready_replicas == replicas:
            return True
        else:
            return False


    def stop(self):
        pod_name = self._pod_name[0]
        print(pod_name)
        controller_status = self.get_controller_kind(pod_name=pod_name, namespace=self._namespace)
        print(controller_status)
        # 1. stop pod
        print('*** stop pod ***')
        if controller_status == 'StatefulSet':
            replicas = self.get_statefulset_replicas()
            self.stop_pod_statefulset(statefulset_name=self.get_statefulset_name())
        elif controller_status == 'ReplicaSet':
            replicas = self.get_deployment_replicas()
            self.stop_pod_deployment(deployment_name=self.get_deployment_name())
        print('*** stop pod success 1 ***')


        time.sleep(40)

        # start
        if controller_status == 'StatefulSet':
            self.start_pod_statefulset(replicas=replicas, statefulset_name=self.get_statefulset_name())
        elif controller_status == 'ReplicaSet':
            self.start_pod_deployment(replicas=replicas, deployment_name=self.get_deployment_name())
        print('*** start pod success 5 ***')


def calculate_md5(file_path):
    """
    计算文件的 MD5 值。
    :param file_path: 文件的完整路径。
    :return: 文件的 MD5 哈希值。
    """
    md5_hash = hashlib.md5()
    with open(file_path, "rb") as file:
        chunk = file.read(8192)
        while chunk:
            md5_hash.update(chunk)
            chunk = file.read(8192)
    return md5_hash.hexdigest()


if __name__ == "__main__":
    newapp_name = input("Please input the name of target app: [example: wordpress-5678]:").strip()
    cloned_app = input("Please input the name of the cloned app: [example wordpress-1234]: ").strip()
    ftp_user = input("Please input FTP username: [example xxx]: ").strip()
    ftp_password = input("Please input FTP password: [example xxx]: ").strip()

    process_len = 10
    # 1. 连接ftp
    ftp_obj = MyFTP()
    # 尝试连接到 FTP 服务器
    status, ftp = ftp_obj.ConnectFTP(
        remote_ip="165.73.249.37",
        remote_port=10021,
        login_name=ftp_user,
        login_password=ftp_password
    )
    if status == 1:
        print(f"\033[32m1. connect ftp. [1/{process_len}]\033[0m")
        print(f"\033[32mSuccessfully connected and logged into the FTP server.\033[0m")
        ftp.quit()  # 结束会话
    else:
        print(f"\033[31mFailed to connect or login: {ftp}\033[0m")
        input("Press Enter to exit.")
        sys.exit(1)

    restore_obj = RestoreLVM()
    # 2. 判断lvm 是否存在
    lvm_info = restore_obj.get_lvm_info(stackname=newapp_name)
    if lvm_info:
        print(f"\033[32m 2.lvm {newapp_name} exists. continue [2/{process_len}]\033[0m")
    else:
        print(f"\033[31mlvm {newapp_name} does not exist. exit\033[0m")
        input("Press Enter to exit.")
        sys.exit(1)

    download_filename = cloned_app + "-clone.tar.gz"


    # 3. 获取md5值
    try:
        print(f"\033[32m 3. get file MD5 value. [3/{process_len}]\033[0m")
        caculate_template_md5(download_filename)
        # 获取模板文件的 MD5 值
        templateinfo = get_template_md5(download_filename)
        template_md5 = templateinfo["md5"]
        print(f"\033[32m template {download_filename} MD5 is：{template_md5}\033[0m")
    except:
        print(f"\033[31mget template {download_filename} MD5 failed\033[0m")


    # 4. 创建软连接
    print(f"\033[32m4. create {download_filename} soft link, [4/{process_len}]\033[0m")
    response_data = create_symlink(download_filename)
    softlinkfile = "ln-vps-tmpl-" + download_filename
    print(f"\033[32mlink create success，the name is：{softlinkfile}\033[0m")

    # 5. 下载文件
    print(f"\033[32m5. download {download_filename} file. [5/{process_len}]\033[0m")
    localPath = os.path.join("/cloudclusters/backup/", newapp_name)
    if not os.path.exists(localPath):
        os.makedirs(localPath)
    localbackupfile = os.path.join(localPath, download_filename)
    download_file_from_ftp(login_name=ftp_user, login_password=ftp_password, remotefile=softlinkfile,
                           localPath=localbackupfile)



    # 6. 计算md5
    print(f"\033[32m6. check md5 sum {localbackupfile}, [6/{process_len}]\033[0m")
    newfile_md5_value = calculate_md5(localbackupfile)
    print(f"\033[32mthe file {localbackupfile} md5 is：{newfile_md5_value}\033[0m")

    # 7. 比较模板文件的 MD5 值
    print(f"\033[32m7. compare MD5 value, [7/{process_len}]\033[0m")
    if template_md5 == newfile_md5_value:
        print("\033[32m MD5 compare success\033[0m")
    else:
        print("\033[31m MD5 compare failed\033[0m")
        print("\033[31mexit\033[0m")
        input("Upload complete. Press Enter to exit...")
        sys.exit(1)


    # 8. 停应用
    print(f"\033[32m8. stop app {newapp_name}, [8/{process_len}]\033[0m")
    podobj = PODinfo(namespace=newapp_name)
    pod_name = podobj._pod_name[0]
    controller_status = podobj.get_controller_kind(pod_name=pod_name, namespace=podobj._namespace)
    print('*** stop pod ***')
    if controller_status == 'StatefulSet':
        replicas = podobj.get_statefulset_replicas()
        podobj.stop_pod_statefulset(statefulset_name=podobj.get_statefulset_name())
    elif controller_status == 'ReplicaSet':
        replicas = podobj.get_deployment_replicas()
        podobj.stop_pod_deployment(deployment_name=podobj.get_deployment_name())
    print('*** stop pod success  ***')

    # 9. 恢复数据
    print(f"\033[32m9. restore data, [9/{process_len}]\033[0m")
    restore_obj.restore_data(stackname=newapp_name, backup_file_fullname=localbackupfile)

    # 10. 启动应用
    print(f"\033[32m10. start app {newapp_name}, [10/{process_len}]\033[0m")
    if controller_status == 'StatefulSet':
        podobj.start_pod_statefulset(replicas=replicas, statefulset_name=podobj.get_statefulset_name())
    elif controller_status == 'ReplicaSet':
        podobj.start_pod_deployment(replicas=replicas, deployment_name=podobj.get_deployment_name())
    print('*** start pod success 5 ***')

    print("恢复成功!")
    input("Press Enter to exit...")



